JsonCpp project page | JsonCpp home page

Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
Json::StreamWriterBuilder Class Reference

Build a StreamWriter implementation. More...

`#include <json/writer.h>`

Inheritance diagram for Json::StreamWriterBuilder:
Collaboration diagram for Json::StreamWriterBuilder:

## Public Member Functions
| StreamWriterBuilder ()
| ~StreamWriterBuilder ()
StreamWriter * | newStreamWriter () const
bool | validate (Json::Value *invalid) const
Value & | operator[] (std::string key)
| A simple way to update a specific setting. More...
Public Member Functions inherited from Json::StreamWriter::Factory
virtual | ~Factory ()

## Static Public Member Functions
static void | setDefaults (Json::Value *settings)
| Called by ctor, but you can use this to reset settings_. More...

## Public Attributes
Json::Value | settings_
| Configuration of this builder. More...

## Detailed Description

Build a StreamWriter implementation.

Usage:

using namespace Json;
Value value = ...;
StreamWriterBuilder builder;
builder["commentStyle"] = "None";
builder["indentation"] = " "; // or whatever you like
std::unique_ptr<Json::StreamWriter> writer(
builder.newStreamWriter());
writer->write(value, &std::cout);
std::cout << std::endl; // add lf and flush

Definition at line 89 of file writer.h.

## Constructor & Destructor Documentation

## ◆ StreamWriterBuilder()

Json::StreamWriterBuilder::StreamWriterBuilder | ( |  | ) |

Definition at line 1127 of file json_writer.cpp.

## ◆ ~StreamWriterBuilder()

Json::StreamWriterBuilder::~StreamWriterBuilder | ( |  | ) |

Definition at line 1131 of file json_writer.cpp.

## Member Function Documentation

## ◆ newStreamWriter()

StreamWriter * Json::StreamWriterBuilder::newStreamWriter | ( |  | ) | const
| virtual

Exceptions

  std::exception | if something goes wrong (e.g. invalid settings)

Implements Json::StreamWriter::Factory.

Definition at line 1133 of file json_writer.cpp.

References JSONCPP_STRING.

Referenced by Json::operator<<().

Here is the caller graph for this function:

## ◆ operator[]()

Value & Json::StreamWriterBuilder::operator[] | ( | std::string | key | ) |

A simple way to update a specific setting.

Definition at line 1192 of file json_writer.cpp.

## ◆ setDefaults()

void Json::StreamWriterBuilder::setDefaults | ( | Json::Value * | settings | ) |
| static

Called by ctor, but you can use this to reset settings_.

Precondition
  'settings' != NULL (but Json::null is fine)

Remarks
  Defaults:
  (*settings)["commentStyle"] = "All";
  (*settings)["indentation"] = "\t";
  (*settings)["enableYAMLCompatibility"] = false;
  (*settings)["dropNullPlaceholders"] = false;
  (*settings)["useSpecialFloats"] = false;
  (*settings)["precision"] = 17;

[StreamWriterBuilderDefaults]

[StreamWriterBuilderDefaults]

Definition at line 1197 of file json_writer.cpp.

## ◆ validate()

bool Json::StreamWriterBuilder::validate | ( | Json::Value * | invalid | ) | const

Returns
  true if 'settings' are legal and consistent; otherwise, indicate bad settings via 'invalid'.

Definition at line 1175 of file json_writer.cpp.

References Json::getValidWriterKeys(), JSONCPP_STRING, and Json::Value::size().

## Member Data Documentation

## ◆ settings_

Json::Value Json::StreamWriterBuilder::settings_

Configuration of this builder.

Available settings (case-sensitive):

- "commentStyle": "None" or "All"
- "indentation": "<anything>"
- "enableYAMLCompatibility": false or true
  - slightly change the whitespace around colons
- "dropNullPlaceholders": false or true
  - Drop the "null" string from the writer's output for nullValues. Strictly speaking, this is not valid JSON. But when the output is being fed to a browser's Javascript, it makes for smaller output and the browser can handle the output just fine.
- "useSpecialFloats": false or true
  - If true, outputs non-finite floating point values in the following way: NaN values as "NaN", positive infinity as "Infinity", and negative infinity as "-Infinity".

You can examine 'settings_` yourself to see the defaults. You can also write and read them just like any JSON Value.

See also
  setDefaults()

Definition at line 114 of file writer.h.

The documentation for this class was generated from the following files:

- include/json/writer.h
- src/lib_json/json_writer.cpp